
GameSettings = GameConfig();

function FullScreen( boolean )
	GameSettings.Fullscreen  = boolean;
end	

function VSync( boolean )
	GameSettings.Vsync  = boolean;
end	

function EnableShadows( boolean )
	GameSettings.Shadows  = boolean;	
end	

function AntiAliasing( boolean )
	GameSettings.AntiAliasing  = boolean;	
end	

function InvaderSpeech( boolean )
	GameSettings.InvaderSpeech  = boolean;	
end	


function ChangeMusicVolume(  percent )
	G.SetMusicVolume( percent * 255.0 );
end

function ChangeSoundVolume(  percent )
	G.SetSoundVolume(  percent * 255.0  );
end


local function CreateResEntry( W , H )
	local A = {};
	A.W = W;
	A.H = H;
	return A;
end

ResolutionArray = {};
ResolutionArray[1] = CreateResEntry( 800 , 600 );
ResolutionArray[2] = CreateResEntry( 1024 , 768 );
ResolutionArray[3] = CreateResEntry( 1280 , 720  );
ResolutionArray[4] = CreateResEntry( 1280 , 960  );
ResolutionArray[5] = CreateResEntry( 1280 , 1024  );
ResolutionArray[6] = CreateResEntry( 1600 , 900 );
ResolutionArray[7] = CreateResEntry( 1600 , 1200  );			

function ChangeResolution( value , num )		
	GameSettings.ScreenWidth = ResolutionArray[ num + 1].W;
	GameSettings.ScreenHeight = ResolutionArray[ num + 1 ].H;		
end			
			
function ChangeQuality( value , num )
	GameSettings.Quality = num;	
end

function ApplySettings( )	
	G.ChangeSettings( GameSettings );	
end

function CancelSettings()
	if( LevelActive ) then
		MainMenu.OpenWindow( "InGameWindow" , true );
	else
		MainMenu.OpenWindow( "StartWindow" , true );
	end
end

function OpenOptions()
	OldSettings = G.GetSettings();
	GameSettings = OldSettings;
	
	if( OldSettings.Fullscreen  ) then
		MainMenu.Message( "FullScreen" , "Check" , " " )	
	else
		MainMenu.Message( "FullScreen" , "UnCheck" , " " )	
	end	
	
	if( OldSettings.InvaderSpeech  ) then
		MainMenu.Message( "InvaderSpeech" , "Check" , " " )	
	else
		MainMenu.Message( "InvaderSpeech" , "UnCheck" , " " )	
	end	
		
	if( OldSettings.Vsync  ) then
		MainMenu.Message( "Vsync" , "Check" , " " )	
	else
		MainMenu.Message( "Vsync" , "UnCheck" , " " )	
	end	
	
	if( OldSettings.AntiAliasing  ) then
		MainMenu.Message( "AntiAliasing" , "Check" , " " )	
	else
		MainMenu.Message( "AntiAliasing" , "UnCheck" , " " )	
	end	
	
	if( OldSettings.Shadows  ) then
		MainMenu.Message( "Shadows" , "Check" , " " )	
	else
		MainMenu.Message( "Shadows" , "UnCheck" , " " )	
	end	
				
	for i,v in pairs( ResolutionArray ) do	
		if( v.W == OldSettings.ScreenWidth and v.H == OldSettings.ScreenHeight ) then
			local data = tostring(i-1);
			MainMenu.Message( "ResComboBox" , "SetIndex" , data );
		end
	end	
	
	--OldMusic = G.GetMusicVolume();
	--OldSound = G.GetSoundVolume();
	
	MainMenu.OpenWindow( "OptionsWindow", true );	
end
	
function ExitOptions()

	if( LevelActive ) then
		MainMenu.OpenWindow( "InGameWindow" , true );
	else
		MainMenu.OpenWindow( "StartWindow" , true );
	end
		
	ApplySettings();
end

