-- These are new default script functions that are used in different parts of the scripts:

dofile( "Scripts/IntroImagePopup.lua" )
dofile( "Scripts/LargeTextPopup.lua" )
dofile( "Scripts/ToolTips.lua" )
dofile( "Scripts/LevelConfig.lua" )		--added by STEFAN for campaign implementation
dofile( "Scripts/SpawnSystem.lua" )
dofile( "Scripts/CinemaSystem.lua" )	-- In-game cinematics / bars
dofile( "Scripts/Intro.lua" )

G.SunMoveRate( 0 )
G.SetTimeOfDay( 0 )
	
-- This creates a new basic camera, and destroys any other camera
function CreateBasicCamera()

	local cam = G.GetCogName( "Camera" )
	if( cam ~= nil and cam.IsValid() ) then
		cam.Destroy()
	end
	G.File( "Data/BasicCamera.xml" );
end

CreateBasicCamera();

-- Play Menu Music:
if( MainMenu == nil or not MainMenu.IsValid() ) then
	G.File( "MenuData/MainMenuCog.xml" );
end

MainMenu.CloseWindow( "ControlsWindow" );
MainMenu.CloseWindow( "OptionsWindow" );
MainMenu.CloseWindow( "CreditsWindow" );
MainMenu.CloseWindow( "BonusWindow" );
MainMenu.CloseWindow( "InvaderViewerWindow" );
MainMenu.CloseWindow( "InGameWindow" );
MainMenu.CloseWindow( "LevelChoiceWindow" );
MainMenu.CloseWindow( "GameOverWindow" );
MainMenu.CloseWindow( "InGameExitWindow" );				
MainMenu.CloseWindow( "StartWindow" ); -- OpenWindow( "StartWindow", false );

if( Traitor == nil or not Traitor.IsValid() ) then
	G.File( "MenuData/TraitorCog.xml" );
end

DeactivateTraitor()
Traitor.CloseWindow( "Special" );

function EnableDoodads()
	if(  false ) then -- G.KeyTriggered( "C" ) ) then -- 
		G.EnableTrap( "rock" )
		G.EnableTrap( "bush" )
		G.EnableTrap( "tree" )
		G.EnableTrap( "mushroom" )
		G.EnableTrap( "bus" )
		G.EnableTrap( "vase" )
		G.EnableTrap( "church" )
		G.EnableTrap( "pit" )
		G.EnableTrap( "bomb" )
	end
end

GMain["EnableDoodads"] = EnableDoodads;


function ScreenCapFunc()	
	if( G.KeyTriggered( "SysReq" ) ) then
		G.ScreenCap()
	end
end
GMain["ScreenCapFunc"] = ScreenCapFunc;

function MonoChrome()
	G.DoPostPass( "MonoChrome",  1, 1, 0 );
end

function Glare()
	G.DoPostPass( "DownSample",  1, 1, 2 );
	G.DoPostPass( "Threshold",  2, 2, 3 );
	G.BlurBuffer( 3 , 5 );
	G.DoPostPass( "FinalGlare" , 1, 3, 0 );
end

PlayIntro()