-------------------------------------------------
--------------- TRAITOR VARIABLES ---------------
-------------------------------------------------

TraitorCanBeHidden = false	-- Does the traitor hide himself when clicked
TraitorBlinkDelay = 10;		-- How often traitor blinks

TraitorTalkTime = 0;		-- Time that traitor talks for
AutoHideTraitor = false		-- Hides the traitor, (not used when deactivated OR manually re-enabled)

-------------------------------------------------
--------------- TRAITOR COMMANDS ----------------
-------------------------------------------------

-- Change traitor's image
function SetTraitorImage( imageName )
	Traitor.SetFrameAnimation( "TraitorImage", imageName, 1, 0 );
end

-- ALWAYS seen
function TraitorTalk(msg)
	EnableTraitor()
		
	TraitorTalkTime = string.len(msg)/20.0
	
	Traitor.SetFrameAnimation( "TraitorImage",  "talk" , TraitorTalkTime , 0 );
	Traitor.SetGuiText( "TraitorText" , msg  , 5 );
	
	G.SimpleStopSound( "TraitorTalk" );
	G.SimplePlaySoundDur( "TraitorTalk", TraitorTalkTime );	-- Speech sound
	
	AutoHideTraitor = true
end

-- Hide traitor and his enable button
function DeactivateTraitor()
	Traitor.CloseWindow( "TraitorEnableWindow" );
	Traitor.CloseWindow( "TraitorWindow" );	
	
	AutoHideTraitor = false
	
	G.SimpleStopSound( "TraitorTalk" );
end

-- Traitor Menu
function EnableTraitor()

	-- TraitorTalkTime
	AutoHideTraitor = false

	Traitor.CloseWindow( "TraitorEnableWindow" );
	Traitor.OpenWindow( "TraitorWindow" );
end
	
-- Be sure and enable traitor by default:
function DisableTraitor()
	
	if TraitorCanBeHidden then
		Traitor.CloseWindow( "TraitorWindow" );
		Traitor.OpenWindow( "TraitorEnableWindow" );
		
	end
	
	G.SimpleStopSound( "TraitorTalk" );
	GRoutines[ "Traitor" ] = nil;			-- Does nothing?
end

function TraitorUpdate()

	TraitorTalkTime = TraitorTalkTime - GameTimeDiff;

	-- Check that traitor is not currently talking
	if( TraitorTalkTime < -10 and AutoHideTraitor ) then
		DisableTraitor()
	end
	
	-- Hide traitor after (5?) seonds of not talking
	if( TraitorTalkTime < 0 ) then
	
		-- Invader Blinking:
		TraitorBlinkDelay = (TraitorBlinkDelay - GameTimeDiff);
		if( TraitorBlinkDelay <= 0 ) then
			TraitorBlinkDelay = math.random( 10,15 );
			Traitor.Message( "TraitorImage", "setanimation", "blink" );
		end	
	end
end

G.SimpleLoadSoundVar( "TraitorTalk", "SFX/TraitorTalkShort", 9 )


GMain["TraitorUpdate"] = TraitorUpdate;











--[[

GMain[ "Traitor" ] = TraitorUpdate;

function TraitorInfo( data  )
	GRoutines[ "Traitor" ] = coroutine.create( TraitorRoutines[ data ]  ) 
end
TraitorInfo( "Main" )

TraitorRoutines = {};
function TraitorRoutines.Main()
	EnableTraitor();
	TraitorTalk( "Hello and Welcome to Base Invaders." );
	Wait( 6 );
	TraitorTalk( "Select an option from the Menu.");
	Wait( 6 );
	TraitorTalk(  "Start Game is a good choice.");
	Wait( 6 );
	TraitorTalk(  "How about bonus? Bonuses are always good.");
	Wait( 6 );
	TraitorTalk(  "Maybe some options? Change some game settings?");
	Wait( 6 );	
	TraitorTalk(  "You seem to be a thoughtful person. I will let you make up your mind.");
	Wait( 6 );
	TraitorTalk(  "I hope to see you later in the game.");
	Wait( 6 );
	DisableTraitor(); 
end

function TraitorRoutines.Options()
	EnableTraitor();
	TraitorTalk( "Ah the options screen!" );
	Wait( 6 );
	TraitorTalk( "You can the game options from this screen." );
	Wait( 6 );
	TraitorTalk( "People always forget click apply to change the settings. But I dont think you will." );
	Wait( 20 );
	DisableTraitor(); 
end

function TraitorRoutines.Bonus()
	EnableTraitor();
	TraitorTalk( "The bonus screen!" );
	Wait( 6 );
	TraitorTalk( "You can see who created this game. They are all really awesome." );
	Wait( 6 );
	TraitorTalk( "You could also look at the invaderpedia with to see all the invaders close up!" );
	Wait( 20 );
	DisableTraitor(); 
end

function TraitorRoutines.LevelSelect()
	EnableTraitor();
	TraitorTalk( "Level Selection Good Choice!" );
	Wait( 6 );
	TraitorTalk( "The tutorial lays out the basic gameplay mechanics." );
	Wait( 6 );
	TraitorTalk( "Quick play is a good options just for fun." );
	Wait( 6 );
	TraitorTalk( "The Campaign is alot of fun for those who like a little reason to their fun." );
	Wait( 20 );
	DisableTraitor(); 
end


function TraitorRoutines.Goodbye()
	EnableTraitor();
	TraitorTalk( "You did a really good job playing Base Invaders!" );
	Wait( 6 );
	TraitorTalk( "Come back soon and remeber to play other great Digipen games." );
	Wait( 6 );
	TraitorTalk( "See you again!" );
	Wait( 6 );
	DisableTraitor(); 
end

]]--



