--Common Level Start Code
function LevelStartup()

	G.Create( "MenuData/HudCog.xml" );
	G.Create( "Data/GameCamera.xml" );
	G.Create( "Data/CursorCog.xml" );

	G.Create( "Data/TutorialLevel.xml" );
	G.SetInvSpeed( 20 );

	HUD.EnterLevel();
	G.SetGameState( InLevel );
	
	G.SetLightTime( 0 );
	G.PostP( "None" );
	--TraitorTalk(" ");
	--G.PlayMusic();
	HUD.Message( "VictoryCondition" , "SetText", "This is the tutorial.\nJust do what he says."  );
	HUD.Message( "LossCondition" , "SetText", "None." );

	G.DisableTrapAll();
	
	TraitorCanBeHidden = false;
	
end

LevelStartup();

WaitingForDone = false;

function WaitOnDoneButton()
	WaitingForDone = true;
	Traitor.SetGuiText( "Special" , "Done"  , 0 );	
	while(WaitingForDone == true) do
		coroutine.yield();
	end
	Traitor.SetGuiText( "Special" , "Skip"  , 0 );
end

function SkipChapter()
	if( WaitingForDone ) then
		WaitingForDone = false;
	else	
		if(current_tut == 9) then
			return
		end
		current_tut = current_tut + 1;		
		tutorialroutine = coroutine.create( Tutorials[ current_tut ] ); 
		coroutine.resume(tutorialroutine)	
	end
	
end

function HudArrow(pos, rot)
	if(GuiArrow == nil or not(GuiArrow.IsValid())) then
		G.Create( "MenuData/GuiArrowCog.xml" );
	end
	GuiArrow.SetGuiPosition( "ArrowImage"  , pos );
	GuiArrow.SetGuiRotation( "ArrowImage" , 3.14 + (rot * 3.14 / 180) );
end

function KillHudArrow()
	if(not(GuiArrow == nil) and GuiArrow.IsValid()) then
		GuiArrow.Destroy();
	end
end

function CreateTutInvader(here)
	G.Create("Data/TutorialInvader_Basic.xml")
	TutorialInvader_Basic.SetPosition(here)
end

function TrapPlace( textname , place, face)
	G.edit( true )
	G.AttemptTrapDrop(textname, place, face); 
	G.edit( false );
end


Tutorials = {};

Tutorials[1]  = function()
	
	TraitorTalk("");
	-- Hide text popup until the text starts:
	KillTextPopup()
	Camera.SetPosition(Vector3(150,50,150))
	GameWait(.1)
	
	Traitor.OpenWindow( "Special" );
	
	Camera.SetEnableCamera(false);
	TraitorTalk("Hey There!");
	GameWait(2);
	LargeTextPopup("Introduction")
	
	TraitorTalk("You're new here, so I'll be helping you.");
	GameWait(5);
	TraitorTalk("You can call me 'Traitor'.");
	GameWait(5);
end

Tutorials[2] = function()	
	TraitorTalk("Let me show you around the place...");
	GameWait(2)
	LargeTextPopup("The HUD")
	Camera.EnableCamera(true, true, true);	
	GameWait(3)
	TraitorTalk("At the top, from left to right, are the following:");
	GameWait(5)
	HudArrow(Vector3( -0.80 , 0.53 , 0 ), 0);
	TraitorTalk("'Open Game Menu' Click here or push ESC to bring up the Game Menu.");
	GameWait(7)
	HudArrow(Vector3( -0.36 , 0.53 , 0 ), 0);
	TraitorTalk("'Game Clock' This shows you how long you've played.");
	GameWait(7)
	HudArrow(Vector3( -0.05 , 0.53 , 0 ), 0);
	TraitorTalk("'Credits' This shows you how much money you have remaining.");
	GameWait(7)
	HudArrow(Vector3( 0.35 , 0.53 , 0 ), 0);
	TraitorTalk("'Kill Counter' This is the number of my brethren you've killed!");
	GameWait(7)
	HudArrow(Vector3( 0.78 , 0.33 , 0 ), 0);
	TraitorTalk("'Invadar' The invader radar shows all the traps and invaders in the world.");
	GameWait(7)
	-- Done at start of next function
	KillHudArrow() 
end

--camera
Tutorials[3] =  function()
	KillHudArrow()
	LargeTextPopup("Camera")	
	TraitorTalk("Next you'll want to learn to move the camera about.")
	GameWait(5)
	Camera.SetVelocity(Vector3(0,0,0))
	Camera.EnableCamera(false, true, false);
	TraitorTalk("To scroll, use the WASD keys, arrow keys, or move the mouse to the screen edges. Try it now!")
	
	-- Wait for the camera to move
	local startpos = Camera.GetPosition()
	local curpos = Camera.GetPosition()
	while( startpos[0] == curpos[0] or startpos[2] == curpos[2] ) do
		coroutine.yield();	
		curpos = Camera.GetPosition()
	end 
	
	GameWait(5)
	
	Camera.SetVelocity(Vector3(0,0,0))
	Camera.EnableCamera(true, true, false);
	TraitorTalk("To rotate, hold down the RIGHT mouse button, and move the mouse left and right. Try it now!")

	-- Wait for the camera to rotate
	local startorient = Camera.GetDirection()
	local curorient = Camera.GetDirection()
	while( startorient[0] == curorient[0] and startorient[2] == curorient[2] ) do
		coroutine.yield();	
		curorient = Camera.GetDirection()
	end 
	
	GameWait(5)
	Camera.SetVelocity(Vector3(0,0,0))
	Camera.SetEnableCamera(true);
	TraitorTalk("To zoom the camera in and out, use the mouse scroll wheel, or the PAGE UP and PAGE DOWN keys. Try it now!")	

	-- Wait for the camera to zoom
	startpos = Camera.GetPosition()
	curpos = Camera.GetPosition()
	while( startpos[1] == curpos[1] ) do
		coroutine.yield();	
		curpos = Camera.GetPosition()
	end 
	
	GameWait(5)
	TraitorTalk("Click the 'Done' Button when you feel you've got the hang of it.")
	WaitOnDoneButton();
--	TraitorTalk("Well that was fun, wasnt it.  Now you can move around the world.")

end

--Invaders
Tutorials[4] =  function()
	LargeTextPopup("Invaders")	
	GameWait(1)
	--Look here!
	
	Camera.RegularMove( Vector3(150,50,150), Vector3(190, 5, 190), 2 )
	Camera.EnableCamera( true, false, false )
	
--	Camera.SetOrientation(FromDirection(Vector3(1,-1,1)))
--	Camera.SetPosition(Vector3(150,50,150))
--	Camera.LookAtPosition( Vector3(150,50,150) )
--	Camera.SetVelocity(Vector3(0,0,0))
--  SetEnableCamera(false)

	--Create bernie
	CreateTutInvader(Vector3(190, 5, 190))
	TutorialInvader_Basic.Hop(20)
	TraitorTalk("Look there!  An invader...")
	GameWait(2)
	
	-- Follow Bernie:
	Camera.LookAtPosition( TutorialInvader_Basic.GetPosition() )
	

	-- This is the throwing tutorial:
	ThrowTutorial = coroutine.create( function()
	
		--Hop Bernie!
		TutorialInvader_Basic.Hop(20)
		GameWait(1)
		TraitorTalk("This is your chance.  Show him what you can do.")
		GameWait(5)
		TraitorTalk("Place your hand over him, and hold down the Left mouse button to pick him up.")
		GameWait(5)
		TraitorTalk("Now, fling your mouse to the side and release the Left mouse button.")
		GameWait(5)
		TraitorTalk("If you throw him hard enough, he'll die.")
		Camera.SetEnableCamera(true)

		--Wait until 1 invader killed
		--InvadersKilledWait(1)
			
	end ) 
	
	-- This stops the tutorial if Bernie ever dies
	while ( TutorialInvader_Basic ~= nil ) do
		
		coroutine.resume( ThrowTutorial );	
		coroutine.yield();					-- Yeilds this coroutine after the Throw Tutorial 
	end
	
	-- TraitorTalk("You're a quick learner...");
	-- TraitorTalk("Ah, well, you already know how to do that...");
	
	TraitorTalk("That got him!");		
	GameWait(4)
	
	Camera.RegularMove( Vector3(150,50,150), Vector3(190, 5, 190), 2 )
	Camera.EnableCamera( true, false, false )
	
	TraitorTalk("Good job! You'll notice you got a little bit of money for killing him.")
	GameWait(5)
	
	
--	TraitorTalk("Lets do something more creative with the next one.")
--	GameWait(5)
	--Place spring trap
	TrapPlace("spring", Vector3(190, 0, 190), Vector3(1,0,0));
	TraitorTalk("There, that's a Spring Trap.")
	GameWait(3)
	CreateTutInvader(Vector3(180, 5, 200))
	TraitorTalk("Grab that invader, place your mouse over the Spring Trap, and release him.")
	--Wait until 2 invaders killed
	InvadersKilledWait(2)
	TraitorTalk("Wee!  That was fun.  Don't worry, there's plenty more where that came from.")
	GameWait(5)	
	-- G.DestroyGroup("traps")	-- Done at start of next section
end

--Tower
Tutorials[5] =  function()
	G.KillAllInvaders()
	Camera.ExitCinemaMode();
	G.DestroyAllTraps()
	KillHudArrow()
	LargeTextPopup("The Tower")

	Camera.RegularMove( Vector3(150,50,150), Vector3(190, 5, 190), 2 )
	Camera.EnableCamera( true, false, false )
		
	--Camera.SetOrientation(FromDirection(Vector3(1,-1,1)))
	--Camera.SetPosition(Vector3(150,50,150))	
	--Camera.SetVelocity(Vector3(0,0,0))
	--Camera.SetEnableCamera(false)

	TraitorTalk("So you've just moved here, so you may not know this...")
	GameWait(5)
	
	TraitorTalk("We locals aren't too friendly.  Uh, Yours Truly not included.")
	GameWait(5)
	TraitorTalk("You're going to want to protect your tower.")
	GameWait(3)
	TraitorTalk("Your tower is...  uh...  oh, you don't have one yet.  Lets fix that.")
	GameWait(5)
	--Place Tower
	G.AttemptTowerDrop(Vector3(170, 0, 190))
	TraitorTalk("There we go!  That's your tower.  You need to protect it from Invaders.")
	GameWait(5)
	HudArrow(Vector3( -0.80 , -0.35 , 0 ), 225);
	TraitorTalk("This is the tower's health bar.  It'll turn to red when the tower gets hurt. When your tower is destroyed, you lose. ");
	GameWait(7)
	TraitorTalk("If you get lost, You can press Spacebar or click on the Tower Icon to zoom to it!")
	GameWait(7)
	
--	TraitorTalk("When your tower is destroyed, you lose.  Thats not good.")
--	GameWait(5)
	KillHudArrow()
end


--Traps
Tutorials[6] =  function()
	Camera.ExitCinemaMode();
	KillHudArrow()
	LargeTextPopup("Traps")
	
	TraitorTalk("Let me show you how to defend your tower.")
	GameWait(4)
	
	-- Wall
	TrapPlace("wall", Vector3(190, 0, 190), Vector3(1,0,0)); 
	TraitorTalk("First and foremost is your Wall.  This blocks the progress of invaders.")
	GameWait(5)
	G.DestroyAllWalls()
	GameWait(1)
	
	-- Hammer
	TrapPlace("hammer", Vector3(190, 0, 190), Vector3(1,0,0)); 
	TraitorTalk("Your first offensive trap is the Giant Hammer. This smashes invaders.")
	GameWait(5)
	TraitorTalk("Some traps, like the Hammer and the Spring, have a fixed number of uses.");
	GameWait(5)
	TraitorTalk("When the uses reach zero, the trap dies.")
	CreateTutInvader(Vector3(195, 0, 190))
	GameWait(2)
	CreateTutInvader(Vector3(195, 0, 190))
	GameWait(2)
	CreateTutInvader(Vector3(195, 0, 190))
	GameWait(2)
	G.DestroyAllTraps()
	GameWait(1)
	
	-- Laser
	TrapPlace("laser", Vector3(190, 0, 190), Vector3(1,0,0)); 
	TraitorTalk("Another trap is the Kill Laser. It shoots a ray of death at nearby invaders.")
	GameWait(5)
	CreateTutInvader(Vector3(200, 0, 190))
	TraitorTalk("These types of traps have Charge Bars.");
	GameWait(3)
	CreateTutInvader(Vector3(200, 0, 190))
	TraitorTalk("Every time the trap activates, it uses some Charge.");
	GameWait(3)
	CreateTutInvader(Vector3(200, 0, 190))
	GameWait(1)
	TraitorTalk("When the Charge reaches zero, it stops activating.");
	GameWait(2)
	CreateTutInvader(Vector3(200, 0, 190))
	GameWait(2)
	TraitorTalk("The Charge Bar will automatically recharge slowly over time for free.");
	GameWait(1)
	CreateTutInvader(Vector3(200, 0, 190))
	GameWait(3)
	G.DestroyAllTraps() -- DestroyGroup("traps")
	GameWait(1)
	
	-- Fan
	TrapPlace("fan", Vector3(190, 0, 190), Vector3(0,0,-1)); 
	TraitorTalk("The last trap I want to show you is the fan.  This trap blows invaders around.")
	GameWait(5)
	CreateTutInvader(Vector3(190, 0, 185))
	TraitorTalk("You can use the Fan to herd invaders in the direction of your other traps.")
	GameWait(5)
end

Tutorials[7] = function()
	G.DestroyAllTraps() -- DestroyGroup("traps")
	G.KillAllInvaders() -- TutorialInvader_Basic.Destroy();
	LargeTextPopup("Trap Placement")	
	TraitorTalk("Lets try placing some traps.");
	GameWait(5);
	G.EnableTrap("wall");
	G.SetPoints( 250 );
	TraitorTalk("There, walls are enabled and you have enough money to place one.")

	local timeToPlaceWall = GameTime
	GameWait(5)
	
	WallPlacement = coroutine.create( function()

		TraitorTalk("Click on the Wall icon on the bottom menu");
		HudArrow(Vector3(-.76, -.35, 0), 180)
		GameWait(5)
		KillHudArrow()
		TraitorTalk("You'll notice your hand has a colored outline of the wall under it.");
		GameWait(5)
		TraitorTalk("That's where your Wall will be placed.");
		GameWait(5)
		TraitorTalk("If the wall is green, it can be placed. If its red, it cannot.");
		GameWait(5);
		TraitorTalk("Go ahead and place your wall.")

	end)
	
	while ( Points == 250 ) do
		coroutine.resume( WallPlacement );	
		coroutine.yield();					-- Yeilds this coroutine after the WallPlacement Tutorial 
	end

	-- Speed Reward Text:
	timeToPlaceWall = timeToPlaceWall - GameTime

	-- Determine a response by the speed of execution:
	if( timeToPlaceWall < 5 ) then
		TraitorTalk("Have you done this before?")
	elseif( timeToPlaceWall < 10 ) then
		TraitorTalk("Wow, you're quick!");	
	elseif( timeToPlaceWall < 20 ) then
		TraitorTalk("Hey, good job!");	
	elseif( timeToPlaceWall < 30 ) then
		TraitorTalk("Good job!");
	else
		TraitorTalk("Nice!");	
	end
			
	
	
	GameWait(3)
	TraitorTalk("If you click then drag, you can place a line of walls all at once. Try it then click done.")
	WaitOnDoneButton();	
	G.DisableTrap("wall");
	TraitorTalk("Some traps require a little more effort.  Lets try placing a Fan trap.");
	GameWait(5)	
	G.DestroyAllWalls()	
	G.EnableTrap("fan");
	G.SetPoints(250);
	
	for y=1,2 do 
		for x=1,2 do 
			CreateTutInvader( Vector3(180, 0, 180) + Vector3( x * 8 , 0 , y * 8 ) )			
		end	
	end

	GameWait(0.5)	

	FanPlacement = coroutine.create( function()

		TraitorTalk("Click on the Fan icon on the bottom menu");
		HudArrow(Vector3(-.76, -.35, 0), 180)
		GameWait(5)
		KillHudArrow()
		TraitorTalk("Like the wall, you'll see the Fan under your mouse.");
		GameWait(5)
		TraitorTalk("Click once to determine its location, then move the mouse.");
		GameWait(5)
		TraitorTalk("You'll see a big arrow pointing to your mouse.");
		GameWait(5)
		TraitorTalk("Click again and the trap will be placed, facing that direction.");
		GameWait(5)
		TraitorTalk("Try placing two or three to blow around the invaders!");

	end)
	
	while ( Points >= 250 ) do
		coroutine.resume( FanPlacement );	
		coroutine.yield();					-- Yeilds this coroutine after the FanPlacement Tutorial 
	end

	TraitorTalk("You got it!")
	GameWait(2)
	TraitorTalk("And remember, right-click at any time to cancel trap placement.");
	GameWait(5)
	G.SetPoints(500);
	G.EnableTrap("wall");
	G.EnableTrap("hammer");
	G.EnableTrap("laser");
	Camera.EnableCamera(true, true, true);	
		
	for y=1,5 do 
		for x=1,5 do 
			 CreateTutInvader( Vector3(170, 0, 170) + Vector3( x * 8 , 0 , y * 8 ) )	
		end	
	end
				
	TraitorTalk("Press SHIFT or MIDDLE MOUSE to get the quick trap menu. Have fun with these basic traps and click done when you are finished.");
	WaitOnDoneButton();	
end

-- Thats all folks!
Tutorials[8] =  function()
	KillHudArrow()
	Traitor.CloseWindow( "Special" );
	LargeTextPopup("That's All!");	
	TraitorTalk("I hope this gives you an idea of what to do.")
	GameWait(5)
	TraitorTalk("We're all done here, but I'll see you later in the game.")
	GameWait(5)
	G.SetGameState( Victory );
end


-- Make sure the values of the text is valid:
SetTextPopupTiming( 1, 2.5, 1 )
LargeTextColor = Color( 1,1,1,1 )

EnableTraitor()
Traitor.SetGuiPosition( "TraitorWindow"  , Vector3(0.6, -0.5, 1) );

current_tut = 1;
tutorialroutine =  coroutine.create( Tutorials[current_tut] );

function LevelExitDesc()
	if( GameState == Victory ) then
		G.ActiveBackGround( 1 );
		return "Tutorial Done!"
	end
	
	if( GameState == QuitLevel ) then
		G.ActiveBackGround( 2 );
		return "Quit Tutorial."
	end
	
	G.ActiveBackGround( 2 );
	return "Quit Tutorial.";
end

function TutorialUpdate()
	if( tutorialroutine ) then	
		local con, error = coroutine.resume(tutorialroutine)
		if( con == false ) then
			G.Mes( error )
			tutorialroutine = nil;
			current_tut = current_tut + 1;
			tutorialroutine = coroutine.create( Tutorials[current_tut] ); 
		end			
	end	
	
	if(not (GameState == InLevel)) then
		KillHudArrow()
		KillTextPopup()
		Traitor.CloseWindow( "Special" );
		--G.SetGameState( Victory );
		dofile( "Scripts/GameOver.lua" );
		--GameOverScreen( "Tutorial Exited" );	
		GMain["TutorialUpdate"] = nil;
		GMain["Traitor"] = nil;
		Tutorials = nil;
		G.SimpleStopSound( "TraitorTalk" );
		
		G.StopMusic();
		if( GameState == Victory ) then
			G.LoadSong("Music/invasion_resisted.mp3");
		else
			G.LoadSong("Music/invasion_unopposed.mp3");
		end

		G.SetNextLoopingMusic( "Music/moxie_socks.mp3" );
		
	end    
end



GMain["Traitor"] = nil;
GMain["Traitor"] = TutorialUpdate;
